
OS=`uname`
ERROR=0

#defaults:
	ECHO="/usr/bin/echo"
	MKDIR="/usr/bin/mkdir"
	TR="/usr/bin/tr"
	WHOAMI="/usr/bin/whoami"
	RM="/usr/bin/rm"
	RMDIR="/usr/bin/rmdir"
	GREP="/usr/bin/grep"
	BINDIR="/usr/local/bin"
	MANPATH="/usr/local/man"
	SLIBCLEAN=$ECHO

	SOEXT="so"	

	# how to test for is-a-symlink
	IS_SYMLINK="-h"  

	LIBENV="LD_LIBRARY_PATH"
	LIBENV2=""
	USE_LIB_ENV="N"
	
#override defaults based on platform quirks:	
if [ "$OS" = "SunOS" ]; then
	INITDIR="/etc/init.d"
	STARTUPDIR="/etc/rc2.d/"
	WHOAMI="/usr/ucb/whoami"
	PGPSDKPIPE="/var/.pgpsdkpipe"
	TR="/usr/ucb/tr"
	PGPSDKD="Y"
	USE_LIB_ENV="Y"
	MANPATH="/usr/share/man"
	BINDIR="/usr/bin"
elif [ "$OS" = "Linux" ]; then
	IS_SYMLINK="-L"
	ECHO="/bin/echo -e"
	MKDIR="/bin/mkdir"
	PGPSDKPIPE="/var/.pgpsdksock"
	RM="/bin/rm"
	RMDIR="/bin/rmdir"
	GREP="/bin/grep"
	PGPSDKD="Y"
	MK_OTHER_DIRS="/usr/local/bin /usr/local/man /usr/local/man/man1"
	if [ -d /etc/rc.d -a -d /etc/rc.d/init.d -a -d /etc/rc.d/rc3.d ]; then
		# redhat
		OS_TYPE="REDHAT"
		INITDIR="/etc/rc.d/init.d"
		STARTUPDIR="/etc/rc.d/rc3.d"
	elif [ -d /etc/rc.d -a -d /etc/rc.d/rc3.d ]; then
		# SuSE
		OS_TYPE="SUSE"
		INITDIR="/etc/init.d"
		STARTUPDIR="/etc/rc.d/rc3.d"
	elif [ -d /etc/init.d -a -d /etc/rc3.d ]; then
		# debian or other relatively standard distro
		OS_TYPE="OTHER"
		INITDIR="/etc/init.d"
		STARTUPDIR="/etc/rc3.d"
	else
		echo "Unknown Linux distribution; please adjust platform.sh or perform a manual installation.";
		exit 1
	fi
elif [ "$OS" = "HP-UX" ]; then
	PGPSDKD="Y"
	PGPSDKPIPE="/var/.pgpsdksock"
	
	BINDIR="/usr/bin"
	MK_OTHER_DIRS="/usr/local/man /usr/local/man/man1"

	SOEXT="sl"

	INITDIR="/sbin/init.d"
	STARTUPDIR="/sbin/rc3.d"
	
	LIBENV="SHLIB_PATH"
	LIBENV2="LD_LIBRARY_PATH"
	USE_LIB_ENV="Y"
elif [ "$OS" = "AIX" ]; then
	AIXMINVER=`uname -r`
	if [ "$AIXMINVER" = "3" ]; then
		INITDIR="/etc/rc.d/init.d"
		STARTUPDIR="/etc/rc.d/rc2.d"
	elif [ "$AIXMINVER" = "2" ]; then
		INITDIR="/etc/rc.d/init.d"
		STARTUPDIR="/etc/rc.d/rc2.d"
	elif [ "$AIXMINVER" = "1" ]; then
		INITDIR="/etc/rc.d/rc2.d"
		STARTUPDIR="/etc/rc.d/rc2.d"
	fi
	BINDIR="/usr/bin"
	MANPATH="/usr/share/man"
	PGPSDKD="Y"
	SLIBCLEAN="/usr/sbin/slibclean"
	LIBENV="LIBPATH"
fi


yes_no ( ) {
	# build the prompt
	PROMPT="$1 ["
	T=`$ECHO $2 | $TR "/[a-z]/" "/[A-Z]/"`
	if [ "$T" = "Y" ]; then
		PROMPT="${PROMPT}Y"
	else 
		PROMPT="${PROMPT}y"
	fi
	PROMPT="${PROMPT}/"
	if [ "$T" = "N" ]; then
		PROMPT="${PROMPT}N"
	else 
		PROMPT="${PROMPT}n"
	fi
	PROMPT="${PROMPT}] "
	# prompt now has "question [y/N] " with default answer, if any, capitalized


	while [ 1 ]; do
		$ECHO "$PROMPT\c"
		read ANSWER
		ANSWER=`$ECHO $ANSWER | $TR "/[a-z]/" "/[A-Z]/"`
		if [ "$ANSWER" = "" -a "$T" != "" ]; then
			if [ "$T" = "Y" ]; then
				return 0
			else 
				return 1
			fi
		fi
		case $ANSWER in
			Y|YES)
				return 0
				break
				;;
			N|NO)
				return 1
				break
				;;
			*)
				;;
		esac
	done
}
