/*____________________________________________________________________________
Copyright (C) 2000 Networks Associates Technology, Inc.
All rights reserved.

$Id: FrmAbout.java,v 1.1 2003/10/27 23:46:19 ishabtay Exp $
____________________________________________________________________________*/

/************************************************************
 *
 * Filename:		FrmAbout.java
 *
 * Author:		Alex Faieta
 * Date:		September 25, 2001
 * Editor:		Notepad
 * Java Version:	Sun Java 1.3.1
 * Description:
 *
 ************************************************************/

// Sun Java packages
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.GridLayout;
import javax.swing.AbstractButton;
import javax.swing.JButton;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

// PGPeBizJava packages
import com.mcafee.ebs.EBiz;


public class FrmAbout extends JInternalFrame
{
	private PGPHelp	m_help	= null;


	/**
	 * Ctor setup
	 */
	public FrmAbout( EBiz biz )
	{
		super( PGPeBizJava_Prompts.FORM_ABOUT_CAPTION, false, true, false, true );
		setSize( 300, 190 );
		setDefaultCloseOperation( DISPOSE_ON_CLOSE );

		m_help = new PGPHelp( biz );

		_addCommandPane();
		_addAboutView();

		show();
	}

	/**
	 * Add the command button panel at the bottom of this form
	 */
	private void _addCommandPane()
	{
		final int C_ROW_COUNT = 1;
		final int C_COLUMN_COUNT = 5;

		JPanel _pnlCmdButton = new JPanel( new GridLayout( C_ROW_COUNT, C_COLUMN_COUNT ) );
		getContentPane().add( _pnlCmdButton, BorderLayout.SOUTH );

		_addButtonSelection( _pnlCmdButton, new JButton( PGPeBizJava_Prompts.COMMON_CANCEL_MSG ),
					PGPeBizJava_RunMode.CANCEL_OPTION );
	}

	/**
	 * Adds the main view for input/output
	 */
	private void _addAboutView()
	{
		final int C_ROW_COUNT = 3;
		final int C_COLUMN_COUNT = 1;

		JPanel _pnlViews = new JPanel( new GridLayout( C_ROW_COUNT, C_COLUMN_COUNT ) );
		getContentPane().add( _pnlViews, BorderLayout.NORTH );

		_addTextDisplay( _pnlViews, m_help.getVersion() );
	}

	/**
	 * Add individual Textboxes to a panel with a caption
	 */
	private void _addTextDisplay( Container ctn, String caption )
	{
		JTextField _txt = new JTextField( caption );
		_txt.setEditable( false );
		ctn.add( _txt );
	}

	/**
	 * Add individual buttons to a panel
	 */
	private void _addButtonSelection( Container ctn, AbstractButton btn, final int btnType )
	{
		btn.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				switch( btnType )
				{
				case PGPeBizJava_RunMode.CANCEL_OPTION:
					dispose();
					break;
				};
			}
		} );
		ctn.add( btn );
	}
}
