/*____________________________________________________________________________
Copyright (C) 2000 Networks Associates Technology, Inc.
All rights reserved.

$Id: FrmKeyGenNew.java,v 1.1 2003/10/27 23:46:19 ishabtay Exp $
____________________________________________________________________________*/

/************************************************************
 *
 * Filename:		FrmKeyGenNew.java
 *
 * Author:		Alex Faieta
 * Date:		September 12, 2001
 * Editor:		Notepad
 * Java Version:	Sun Java 1.3.1
 * Description:
 *
 ************************************************************/

// Sun Java packages
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.InputMethodListener;
import java.awt.event.InputMethodEvent;
import javax.swing.AbstractButton;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.text.JTextComponent;

// PGPeBizJava packages
import com.mcafee.ebs.EBiz;


public class FrmKeyGenNew extends JInternalFrame
{
	private JComboBox	m_cboPublicKeyAlgs	= null;
	private JComboBox	m_cboDHKeySize		= null;
	private JTextField	m_txtUserId		= null;
	private JTextField	m_txtPassPhrase		= null;
	private JTextField	m_txtPassPhraseConfirm	= null;
	private PGPKeys		m_keys			= null;


	/**
	 * Ctor setup
	 */
	public FrmKeyGenNew( EBiz biz )
	{
		super( PGPeBizJava_Prompts.FORM_KEY_GEN_NEW_CAPTION, false, true, false, true );
		setSize( 500, 190 );
		setOpaque( true );
		setDefaultCloseOperation( DISPOSE_ON_CLOSE );
		getContentPane().setLayout( new BorderLayout() );

		m_cboPublicKeyAlgs = new JComboBox( PGPeBizJava_RunMode.m_publicKeyAlgs );
		m_cboDHKeySize = new JComboBox( PGPeBizJava_RunMode.m_DHKeySizes );
		m_txtUserId = new JTextField();
		m_txtPassPhrase = new JPasswordField();
		m_txtPassPhraseConfirm = new JPasswordField();

		m_keys = new PGPKeys( biz );

		_addCommandPanel();
		_addUserKeyView();

		_resetForm();

		show();
	}


	/**
	 * Add the command button panel at the bottom of this form
	 */
	private void _addCommandPanel()
	{
		final int C_ROW_COUNT = 1;
		final int C_COLUMN_COUNT = 1;

		JPanel _pnlCmdButton = new JPanel( new GridLayout( C_ROW_COUNT, C_COLUMN_COUNT ) );
		getContentPane().add( _pnlCmdButton, BorderLayout.SOUTH );

		_addButtonSelection( _pnlCmdButton, new JButton( PGPeBizJava_Prompts.KEY_ADD_NEW_MSG ), PGPeBizJava_RunMode.KEY_ADD_NEW );
		_addButtonSelection( _pnlCmdButton, new JButton( PGPeBizJava_Prompts.COMMON_CLEAR_MSG ), PGPeBizJava_RunMode.CLEAR_DATA );
		_addButtonSelection( _pnlCmdButton, new JButton( PGPeBizJava_Prompts.COMMON_CANCEL_MSG ), PGPeBizJava_RunMode.CANCEL_OPTION );
	}

	private void _addButtonSelection( Container _ctn, AbstractButton _btn, final int _btnType )
	{
		_btn.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				switch( _btnType )
				{
				case PGPeBizJava_RunMode.CANCEL_OPTION:
					dispose();
					break;

				case PGPeBizJava_RunMode.KEY_ADD_NEW:
					_saveNewKey();
					break;

				case PGPeBizJava_RunMode.CLEAR_DATA:
					_resetForm();
					break;
				};
			}
		} );
		_ctn.add( _btn );
	}

	/**
	 * Add individual labels to a container
	 */
	private void _addLabelDisplay( Container _ctn, JLabel _lbl )
	{
		_lbl.setSize(30, 30 );
		_ctn.add( _lbl );
	}

	/**
	 * Add individual Textboxs to a container with a button type
	 */
	private void _addTextDisplay( Container _ctn, JTextComponent _txt, final int _btnType )
	{
		_txt.addInputMethodListener( new InputMethodListener() {
			public void inputMethodTextChanged( InputMethodEvent event ) {
				switch( _btnType )
				{
				};
			}
			public void caretPositionChanged( InputMethodEvent event ) { }
		} );
		_ctn.add( _txt );
	}

	/**
	 * Add individual Textboxs to a container
	 */
	private void _addTextDisplay( Container _ctn, JTextComponent _txt )
	{
		_addTextDisplay( _ctn, _txt, PGPeBizJava_RunMode.INVALID_OPTION );
	}

	/**
	 * Add individual Comboboxes to a panel with a buttontype
	 */
	private void _addComboDisplay( Container _ctn, JComboBox _cbo, final int _btnType )
	{
		_cbo.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				switch( _btnType )
				{
				}
			}
		} );
		_ctn.add( _cbo );
	}

	/**
	 * Add individual Comboboxes to a panel
	 */
	private void _addComboDisplay( Container _ctn, JComboBox _cbo )
	{
		_addComboDisplay( _ctn, _cbo, PGPeBizJava_RunMode.INVALID_OPTION );
	}

	/**
	 * Adds the main view for input/output
	 */
	private void _addUserKeyView()
	{
		final int C_ROW_COUNT = 5;
		final int C_COLUMN_COUNT = 2;

		JPanel _pnlViews = new JPanel( new GridLayout( C_ROW_COUNT, C_COLUMN_COUNT ) );
		_addLabelDisplay( _pnlViews, new JLabel( PGPeBizJava_Prompts.KEY_GEN_PUBLIC_ALG_LBL ) );
		_addComboDisplay( _pnlViews, m_cboPublicKeyAlgs );

		_addLabelDisplay( _pnlViews, new JLabel( PGPeBizJava_Prompts.KEY_GEN_DH_KEY_SIZE_LBL ) );
		_addComboDisplay( _pnlViews, m_cboDHKeySize );

		_addLabelDisplay( _pnlViews, new JLabel( PGPeBizJava_Prompts.KEY_GEN_USER_ID_LBL ) );
		_addTextDisplay( _pnlViews, m_txtUserId );

		_addLabelDisplay( _pnlViews, new JLabel( PGPeBizJava_Prompts.KEY_GEN_PASS_PHRASE_LBL ) );
		_addTextDisplay( _pnlViews, m_txtPassPhrase );

		_addLabelDisplay( _pnlViews, new JLabel( PGPeBizJava_Prompts.KEY_GEN_PASS_PHRASE_CONFIRM_LBL ) );
		_addTextDisplay( _pnlViews, m_txtPassPhraseConfirm );

		getContentPane().add( _pnlViews, BorderLayout.NORTH );
	}

	/**
	 * Saves the user data when the form entry is valid.
	 * Displays prompts when unsuccessful. Display prompt when
	 * successful/unsuccessful saving.
	 */
	private void _saveNewKey()
	{
		if( ! _IsFormEntryValid() )
		{
			JOptionPane.showMessageDialog( this,
							PGPeBizJava_Prompts.KEY_GEN_NEW_INCOMPLETE_DATA_MSG,
							PGPeBizJava_Prompts.KEY_GEN_NEW_INCOMPLETE_DATA_TITLE,
							JOptionPane.ERROR_MESSAGE );
			return;
		}

		// CHECK PASSPHRASES
		if( m_txtPassPhrase.getText().compareTo( m_txtPassPhraseConfirm.getText() ) != 0 )
		{
			JOptionPane.showMessageDialog( this,
							PGPeBizJava_Prompts.KEY_GEN_PASS_PHRASES_NO_MATCH_MSG,
							PGPeBizJava_Prompts.KEY_GEN_NEW_INCOMPLETE_DATA_TITLE,
							JOptionPane.ERROR_MESSAGE );
			return;
		}

		// RSA LEGACY AND 3072 BIT DH SIZE NOT AVAILABLE
		if(	_getSelectedPublicKeyAlg().compareTo( PGPeBizJava_CmdlineArgs.C_KEY_ALG_RSA_LEGACY_CMDLINE ) == 0		&&
			_getSelectedDHSize().compareTo( PGPeBizJava_CmdlineArgs.C_DH_SIZE_3072_CMDLINE ) == 0	)
		{
			JOptionPane.showMessageDialog( this,
							PGPeBizJava_Prompts.KEY_GEN_RSA_LEGACY_3072_BIT_ERR_MSG,
							PGPeBizJava_Prompts.KEY_GEN_NEW_INCOMPLETE_DATA_MSG,
							JOptionPane.ERROR_MESSAGE );
			return;
		}


		// ADD THE NEW GENERATED KEY
		boolean _isAdded = m_keys.addNewKey(	m_txtUserId.getText(), m_txtPassPhrase.getText(),
							_getSelectedPublicKeyAlg(), _getSelectedDHSize()	);

		if( _isAdded )
		{
			JOptionPane.showMessageDialog( this,
							PGPeBizJava_Prompts.KEY_GEN_NEW_SUCCESS_MSG,
							PGPeBizJava_Prompts.KEY_GEN_NEW_SUCCESS_TITLE,
							JOptionPane.INFORMATION_MESSAGE );
			_resetForm();
		}
		else
			JOptionPane.showMessageDialog( this,
							PGPeBizJava_Prompts.KEY_GEN_NEW_INCOMPLETE_DATA_MSG + "\n" + m_keys.getCmdInputString(),
							PGPeBizJava_Prompts.KEY_GEN_NEW_INCOMPLETE_DATA_TITLE,
							JOptionPane.ERROR_MESSAGE );
	}

	/**
	 * Resets the form for input
	 */
	private void _resetForm()
	{
		m_cboPublicKeyAlgs.setSelectedIndex( 0 );
		m_cboDHKeySize.setSelectedIndex( 0 );
		m_txtUserId.setText( "" );
		m_txtPassPhrase.setText( "" );
		m_txtPassPhraseConfirm.setText( "" );

		m_cboPublicKeyAlgs.grabFocus();
	}

	/**
	 * Determines if the form is valid
	 */
	private boolean _IsFormEntryValid()
	{
		Util _util = new Util();

		if(	_util.isTextBoxEmpty( m_txtUserId )			||
			_util.isTextBoxEmpty( m_txtPassPhrase )		||
			_util.isTextBoxEmpty( m_txtPassPhraseConfirm )	)
				return false;


		return true;
	}

	/**
	 * Gets the currently selected Public Key Algorithm within
	 * the combobox
	 */
	private String _getSelectedPublicKeyAlg()
	{
		final int C_KEY_ALG_DH_DSS	= 0;
		final int C_KEY_ALG_RSA		= 1;
		final int C_KEY_ALG_RSA_LEGACY	= 2;

		String _selAlg = (String) m_cboPublicKeyAlgs.getSelectedItem();


		if(  _selAlg.compareTo( PGPeBizJava_RunMode.m_publicKeyAlgs[ C_KEY_ALG_DH_DSS ] ) == 0  )
			return PGPeBizJava_CmdlineArgs.C_KEY_ALG_DH_DSS_CMDLINE;

		else if(  _selAlg.compareTo( PGPeBizJava_RunMode.m_publicKeyAlgs[ C_KEY_ALG_RSA ] ) == 0  )
			return PGPeBizJava_CmdlineArgs.C_KEY_ALG_RSA_CMDLINE;

		else if(  _selAlg.compareTo( PGPeBizJava_RunMode.m_publicKeyAlgs[ C_KEY_ALG_RSA_LEGACY ] ) == 0  )
			return PGPeBizJava_CmdlineArgs.C_KEY_ALG_RSA_LEGACY_CMDLINE;


		return new String();
	}

	/**
	 * Gets the currently selected DH Size within
	 * the combobox
	 */
	private String _getSelectedDHSize()
	{
		final int C_DH_SIZE_1024	= 0;
		final int C_DH_SIZE_2048	= 1;
		final int C_DH_SIZE_3072	= 2;

		String _selDHSize = (String) m_cboDHKeySize.getSelectedItem();


		if(  _selDHSize.compareTo( PGPeBizJava_RunMode.m_DHKeySizes[ C_DH_SIZE_1024 ] ) == 0  )
			return PGPeBizJava_CmdlineArgs.C_DH_SIZE_1024_CMDLINE;

		else if(  _selDHSize.compareTo( PGPeBizJava_RunMode.m_DHKeySizes[ C_DH_SIZE_2048 ] ) == 0  )
			return PGPeBizJava_CmdlineArgs.C_DH_SIZE_2048_CMDLINE;

		else if(  _selDHSize.compareTo( PGPeBizJava_RunMode.m_DHKeySizes[ C_DH_SIZE_3072 ] ) == 0  )
			return PGPeBizJava_CmdlineArgs.C_DH_SIZE_3072_CMDLINE;


		return new String();
	}
}
