/*____________________________________________________________________________
Copyright (C) 2000 Networks Associates Technology, Inc.
All rights reserved.

$Id: FrmMain.java,v 1.1 2003/10/27 23:46:20 ishabtay Exp $
____________________________________________________________________________*/

/************************************************************
 *
 * Filename:		FrmMain.java
 *
 * Author:		Alex Faieta
 * Date:		September 11, 2001
 * Editor:		Notepad
 * Java Version:	Sun Java 1.3.1
 * Description:		
 *
 ************************************************************/

// Sun Java packages
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import javax.swing.JDesktopPane;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.KeyStroke;


public class FrmMain	extends JFrame
			implements ActionListener
{
	FrmMain_Menu m_menu = null;
	FrmMain_Controller m_controller = null;


	/**
	 * Ctor setup
	 */
	public FrmMain()
	{
		super( PGPeBizJava_Prompts.FORM_MAIN_CAPTION );
		setSize( 700, 600 );
		setLocation( 300, 300 );
		setDefaultCloseOperation( EXIT_ON_CLOSE );


		_loadForm();
		_setMenuSelection();

		show();
	}

	/**
	 * Main initialization
	 */
	private void _loadForm()
	{
		m_menu = new FrmMain_Menu();

		JDesktopPane _jDesk = new JDesktopPane();
		_jDesk.setOpaque( true );
		setContentPane( _jDesk );

		m_controller = new FrmMain_Controller( _jDesk );
	}


	private void _setMenuSelection()
	{
		setJMenuBar( new JMenuBar() );

		_addMenu( getMenuCaption( m_menu.FILE ) );
		_addMenuItem( m_menu.FILE_MENU_IDX, getMenuCaption( m_menu.FILE_RUN_COMMAND ), true, KeyEvent.VK_R );
		_addMenuItem( m_menu.FILE_MENU_IDX, getMenuCaption( m_menu.FILE_EXIT ), true, KeyEvent.VK_X );

		_addMenu( getMenuCaption( m_menu.KEYS ) );
		_addMenuItem( m_menu.KEYS_MENU_IDX, getMenuCaption( m_menu.KEYS_GEN_NEW ), true, KeyEvent.VK_A );
		_addMenuItem( m_menu.KEYS_MENU_IDX, getMenuCaption( m_menu.KEYS_LIST_KEYS ), true, KeyEvent.VK_I );
		_addMenuItem( m_menu.KEYS_MENU_IDX, getMenuCaption( m_menu.KEYS_LIST_KEY_INFO ), true, KeyEvent.VK_N );
		_addMenuItem( m_menu.KEYS_MENU_IDX, getMenuCaption( m_menu.KEYS_IMPORT_KEYS ), true, KeyEvent.VK_P );

		_addMenu( getMenuCaption( m_menu.ENCRYPT ) );
		_addMenuItem( m_menu.ENCRYPT_MENU_IDX, getMenuCaption( m_menu.ENCRYPT_ENC_FILE ), true, KeyEvent.VK_E );
		_addMenuItem( m_menu.ENCRYPT_MENU_IDX, getMenuCaption( m_menu.ENCRYPT_DEC_FILE ), true, KeyEvent.VK_D );
		_addMenuItem( m_menu.ENCRYPT_MENU_IDX, getMenuCaption( m_menu.ENCRYPT_COMPARE ), true );
		_addMenuItem( m_menu.ENCRYPT_MENU_IDX, getMenuCaption( m_menu.ENCRYPT_WIPE_FILES ), true );

		_addMenu( getMenuCaption( m_menu.HELP ) );
		_addMenuItem( m_menu.HELP_MENU_IDX, getMenuCaption( m_menu.HELP_COMMANDS ), true, KeyEvent.VK_C );
		_addMenuItem( m_menu.HELP_MENU_IDX, getMenuCaption( m_menu.HELP_ABOUT ), true, KeyEvent.VK_A );
	}

	/**
	 * Gets the menu caption from an index
	 */
	private String getMenuCaption( int idx )
	{
		return FrmMain_Menu.getCaption( idx );
	}

	/**
	 * Adds individual menu items to the main form
	 */
	private void _addMenu( String caption )
	{
		JMenu _mnu = new JMenu( caption );
		getJMenuBar().add( _mnu );
	}

	/**
	 * Adds individual menu items to a main menu drop-down list
	 */
	private void _addMenuItem( final int mnuIdx, String caption, boolean isEvent )
	{
		JMenuItem _mnuItem = new JMenuItem( caption );
		if( isEvent )
			_mnuItem.addActionListener( this );

		getJMenuBar().getMenu( mnuIdx ).add( _mnuItem );
	}

	/**
	 * Adds individual menu items to a main menu drop-down list
	 */
	private void _addMenuItem( final int mnuIdx, String caption, boolean isEvent, final int mnemonic )
	{
		_addMenuItem( mnuIdx, caption, isEvent );
		getJMenuBar().getMenu( mnuIdx ).setMnemonic( mnemonic );
	}

	/**
	 * User selected menu item events
	 */
	public void actionPerformed( ActionEvent event )
	{
		String _cmdStr = event.getActionCommand();

		if(  _isSelectedMenu( _cmdStr, m_menu.FILE_EXIT )  )
			System.exit( 0 );

		else if(  _isSelectedMenu( _cmdStr, m_menu.FILE_RUN_COMMAND )  )
			m_controller.doRunCommand();

		else if(  _isSelectedMenu( _cmdStr, m_menu.KEYS_GEN_NEW )  )
			m_controller.doKeyAddNew();

		else if(  _isSelectedMenu( _cmdStr, m_menu.KEYS_LIST_KEYS )  )
			m_controller.doListKeys();

		else if(  _isSelectedMenu( _cmdStr, m_menu.KEYS_LIST_KEY_INFO )  )
			m_controller.doKeyInfo();

		else if(  _isSelectedMenu( _cmdStr, m_menu.KEYS_IMPORT_KEYS )  )
			m_controller.doImportKeys();

		else if(  _isSelectedMenu( _cmdStr, m_menu.ENCRYPT_ENC_FILE )  )
			m_controller.doEncryptFile();

		else if(  _isSelectedMenu( _cmdStr, m_menu.ENCRYPT_DEC_FILE )  )
			m_controller.doDecryptFile();

		else if(  _isSelectedMenu( _cmdStr, m_menu.ENCRYPT_COMPARE )  )
			m_controller.doCompareFiles();

		else if(  _isSelectedMenu( _cmdStr, m_menu.ENCRYPT_WIPE_FILES )  )
			m_controller.doWipeFiles();

		else if(  _isSelectedMenu( _cmdStr, m_menu.HELP_COMMANDS )  )
			m_controller.doHelpCommands();

		else if(  _isSelectedMenu( _cmdStr, m_menu.HELP_ABOUT )  )
			m_controller.doHelpAbout();
	}

	/**
	 * Compares the menu selected caption to the menu index of
	 * the form caption
	 */
	private boolean _isSelectedMenu( String actionCmd, int mnuIdx )
	{
		if( actionCmd.compareTo( getMenuCaption( mnuIdx ) ) == 0 )
			return true;

		return false;
	}
}
