/*____________________________________________________________________________
Copyright (C) 2000 Networks Associates Technology, Inc.
All rights reserved.

$Id: FrmMain_Controller.java,v 1.1 2003/10/27 23:46:20 ishabtay Exp $
____________________________________________________________________________*/

/************************************************************
 *
 * Filename:		FrmMain_Controller.java
 *
 * Author:		Alex Faieta
 * Date:		September 12, 2001
 * Editor:		Notepad
 * Java Version:	Sun Java 1.3.1
 * Description:
 *
 ************************************************************/

// Sun Java packages
import java.beans.PropertyVetoException;
import java.io.File;
import javax.swing.JDesktopPane;
import javax.swing.JInternalFrame;
import javax.swing.JOptionPane;

// PGPeBizJava packages
import com.mcafee.ebs.EBiz;


public class FrmMain_Controller
{
	private JDesktopPane m_jDesk = null;
	private EBiz m_biz = null;


	/**
	 * Ctor setup
	 */
	public FrmMain_Controller( JDesktopPane jDesk )
	{
		m_jDesk = jDesk;
		m_biz = new EBiz();
	}



	/**
	 * Display encryption form
	 */
	public void doEncryptFile()
	{
		FrmEncryption _frmEncrypt = new FrmEncryption(	PGPeBizJava_Prompts.FORM_ENCRYPT_FILES_CAPTION,
								m_biz,
								PGPeBizJava_RunMode.ENCRYPT_FILE );
		m_jDesk.add( _frmEncrypt );
	}

	/**
	 * Display decryption form
	 */
	public void doDecryptFile()
	{
		FrmEncryption _frmDecrypt = new FrmEncryption(	PGPeBizJava_Prompts.FORM_DECRYPT_FILES_CAPTION,
								m_biz,
								PGPeBizJava_RunMode.DECRYPT_FILE );
		m_jDesk.add( _frmDecrypt );
	}

	/**
	 * Display comparison form
	 */
	public void doCompareFiles()
	{
		FrmEncryption _frmCompare = new FrmEncryption(	PGPeBizJava_Prompts.FORM_COMPARE_FILES_CAPTION,
								m_biz,
								PGPeBizJava_RunMode.COMPARE_FILES );
		m_jDesk.add( _frmCompare );
	}

	/**
	 * Display PGP keys form
	 */
	public void doListKeys()
	{
		FrmListKeys _frmListKeys = new FrmListKeys( m_biz );
		m_jDesk.add( _frmListKeys );
	}

	/**
	 * Display individual PGP key information
	 */
	public void doKeyInfo()
	{
		FrmListKeyInfo _frmKeyDetail = new FrmListKeyInfo( m_biz );
		m_jDesk.add( _frmKeyDetail );
	}

	/**
	 * Display help commands form
	 */
	public void doHelpCommands()
	{
		FrmHelpCommands _frmHelpCmd = new FrmHelpCommands( m_biz );
		m_jDesk.add( _frmHelpCmd );
	}

	/**
	 * Display About form
	 */
	public void doHelpAbout()
	{
		FrmAbout _frmAbout = new FrmAbout( m_biz );
		m_jDesk.add( _frmAbout );
	}

	/**
	 * Display PGP key generation form
	 */
	public void doKeyAddNew()
	{
		FrmKeyGenNew _frmGenNewKey = new FrmKeyGenNew( m_biz );
		m_jDesk.add( _frmGenNewKey );
	}

	/**
	 * Display Run customized command form
	 */
	public void doRunCommand()
	{
		FrmRunCommand _frmRunCommand = new FrmRunCommand( m_biz );
		m_jDesk.add( _frmRunCommand );
	}

	/**
	 * Display Wipe files form
	 */
	public void doWipeFiles()
	{
		FrmEncryption _frmWipeFiles = new FrmEncryption(	PGPeBizJava_Prompts.FORM_WIPE_FILES_CAPTION,
									m_biz,
									PGPeBizJava_RunMode.WIPE_FILES );
		m_jDesk.add( _frmWipeFiles );
	}

	/**
	 * Import multiple PGP keys
	 */
	public void doImportKeys()
	{
		PGPKeys _keys = new PGPKeys( m_biz );
		Util _util = new Util();

		File[] _files = _util.selectFiles();

		for( int idx=0; idx < _files.length; idx++ )
		{
			if(  _keys.importKey( _files[ idx ] )  )
				JOptionPane.showMessageDialog( null, PGPeBizJava_Prompts.KEY_IMPORT_KEY_SUCCESS_MSG );
			else
				JOptionPane.showMessageDialog( null, PGPeBizJava_Prompts.KEY_IMPORT_KEY_UNSUCCESS_MSG + "\n" + _files[ idx ] );
		}
	}
}
