/*____________________________________________________________________________
Copyright (C) 2000 Networks Associates Technology, Inc.
All rights reserved.

$Id: FrmRunCommand.java,v 1.1 2003/10/27 23:46:20 ishabtay Exp $
____________________________________________________________________________*/

/************************************************************
 *
 * Filename:		FrmRunCommand.java
 *
 * Author:		Alex Faieta
 * Date:		September 14, 2001
 * Editor:		Notepad
 * Java Version:	Sun Java 1.3.1
 * Description:
 *
 ************************************************************/

// Sun Java packages
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.InputMethodListener;
import java.awt.event.InputMethodEvent;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.GridLayout;
import javax.swing.AbstractButton;
import javax.swing.JButton;
import javax.swing.JInternalFrame;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JScrollPane;
import javax.swing.text.JTextComponent;

// PGPeBizJava packages
import com.mcafee.ebs.EBiz;


public class FrmRunCommand extends JInternalFrame
{
	private JTextField	m_txtCommand		= null;
	private JTextArea	m_txtCommandResult	= null;
	private PGPRun		m_run			= null;


	/**
	 * Ctor setup
	 */
	public FrmRunCommand( EBiz biz )
	{
		super( PGPeBizJava_Prompts.FORM_RUN_COMMAND_CAPTION, false, true, false, true );
		setSize( 400, 390 );
		setDefaultCloseOperation( DISPOSE_ON_CLOSE );

		m_run = new PGPRun( biz );
		m_txtCommand = new JTextField();
		m_txtCommandResult = new JTextArea( 18, 1 );

		_addCommandPanel();
		_addUserKeyView();

		m_txtCommand.grabFocus();

		show();
	}

	/**
	 * Add the command button panel at the bottom of this form
	 */
	private void _addCommandPanel()
	{
		final int C_ROW_COUNT = 1;
		final int C_COLUMN_COUNT = 3;

		JPanel _pnlCmdButton = new JPanel( new GridLayout( C_ROW_COUNT, C_COLUMN_COUNT ) );
		getContentPane().add( _pnlCmdButton, BorderLayout.SOUTH );

		_addButtonSelection( _pnlCmdButton, new JButton( PGPeBizJava_Prompts.COMMON_RUN_COMMAND_MSG ), PGPeBizJava_RunMode.RUN_COMMAND );
		_addButtonSelection( _pnlCmdButton, new JButton( PGPeBizJava_Prompts.COMMON_CLEAR_MSG ), PGPeBizJava_RunMode.CLEAR_DATA );
		_addButtonSelection( _pnlCmdButton, new JButton( PGPeBizJava_Prompts.COMMON_CANCEL_MSG ), PGPeBizJava_RunMode.CANCEL_OPTION );
	}

	/**
	 * Adds the main view for input/output
	 */
	private void _addUserKeyView()
	{
		final int C_ROW_COUNT = 2;
		final int C_COLUMN_COUNT = 1;

		JPanel _pnlView = new JPanel( new BorderLayout() );
		getContentPane().add( _pnlView, BorderLayout.NORTH );


		_addTextDisplay( _pnlView, m_txtCommand, PGPeBizJava_RunMode.RUN_COMMAND, BorderLayout.NORTH );
		_pnlView.add( new JScrollPane( m_txtCommandResult ), BorderLayout.CENTER );
	}

	/**
	 * Add individual Textboxs to a panel with a location
	 */
	private void _addTextDisplay( Container _ctn, JTextField _txt, final int _btnType, String location )
	{
		_txt.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				switch( _btnType )
				{
				case PGPeBizJava_RunMode.RUN_COMMAND:
					_runCommand();
					break;
				};
			}
		} );
		_ctn.add( _txt, location );
	}

	/**
	 * Add individual buttons to a panel
	 */
	private void _addButtonSelection( Container _ctn, AbstractButton _btn, final int _btnType )
	{
		_btn.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				switch( _btnType )
				{
				case PGPeBizJava_RunMode.CANCEL_OPTION:
					dispose();
					break;

				case PGPeBizJava_RunMode.RUN_COMMAND:
					_runCommand();
					break;

				case PGPeBizJava_RunMode.CLEAR_DATA:
					_resetForm();
					break;
				};
			}
		} );
		_ctn.add( _btn );
	}

	/**
	 * Runs the user command
	 */
	private void _runCommand()
	{
		m_txtCommandResult.setText( m_run.runCommand(
						m_txtCommand.getText()
					) );

		m_txtCommandResult.setCaretPosition( 0 );
	}

	/**
	 * Resets the form for input
	 */
	private void _resetForm()
	{
		m_txtCommand.setText( "" );
		m_txtCommandResult.setText( "" );
	}
}
