/*____________________________________________________________________________
Copyright (C) 2000 Networks Associates Technology, Inc.
All rights reserved.

$Id: PGPRun.java,v 1.1 2003/10/27 23:46:21 ishabtay Exp $
____________________________________________________________________________*/

/************************************************************
 *
 * Filename:		PGPRun.java
 *
 * Author:		Alex Faieta
 * Date:		September 24, 2001
 * Editor:		Notepad
 * Java Version:	Sun Java 1.3.1
 * Description:
 *
 ************************************************************/

// PGPeBizJava packages
import com.mcafee.ebs.EBiz;


public class PGPRun
{
	private EBiz	m_biz = null;


	/**
	 * Ctor setup
	 */
	public PGPRun( EBiz biz )
	{
		m_biz = biz;
	}

	/**
	 * Run a PGP command
	 */
	public String runCommand( String args )
	{
		return this.runCommand( args, new String() );
	}

	/**
	 * Sets the input before running a PGP command
	 */
	public String runCommand( String args, String stdin )
	{
		String _runCmd = args;

		m_biz.stdin( stdin );
		if( m_biz.run( _runCmd ) == false )
		{
			return new String( "Error: " + m_biz.error_string() );
		}

		if(  ! _isCheckStreamValid()  )
			return new String();

		return new String( m_biz.stdout() );
	}

	/**
	 * Validates the PGP output
	 */
	private boolean _isCheckStreamValid()
	{
		if( m_biz.stdout() != null )
			return true;

		return false;
	}

	/**
	 * Run a PGP command if valid
	 */
	public boolean isRunCommand( String args )
	{
		return this.isRunCommand( args, new String() );
	}

	/**
	 * Sets the input before running a PGP command if valid
	 */
	public boolean isRunCommand( String args, String stdin )
	{
		m_biz.stdin( stdin );
		if( m_biz.run( args ) == false )
			return false;

		return true;
	}
}
