/*____________________________________________________________________________
Copyright (C) 2000 Networks Associates Technology, Inc.
All rights reserved.

$Id: PGPeBizJava_CmdlineArgs.java,v 1.1 2003/10/27 23:46:21 ishabtay Exp $
____________________________________________________________________________*/

/************************************************************
 *
 * Filename:		PGPeBizJava_CmdlineArgs.java
 *
 * Author:		Alex Faieta
 * Date:		September 13, 2001
 * Editor:		Notepad
 * Java Version:	Sun Java 1.3.1
 * Description:		Resource file of all the PGP command
 *			line arguments.
 *
 ************************************************************/




public final class PGPeBizJava_CmdlineArgs
{
	// FILE EXTENSIONS
	public static final String C_ARMOR_FILE_EXTENSION		= ".asc";
	public static final String C_WITHOUT_ARMOR_FILE_EXTENSION	= ".pgp";

	// PUBLIC KEY ALGORITHM TYPES
	public static final String C_KEY_ALG_DH_DSS_CMDLINE		= "DSS";
	public static final String C_KEY_ALG_RSA_CMDLINE		= "RSA";
	public static final String C_KEY_ALG_RSA_LEGACY_CMDLINE		= "RSA-Legacy";

	// KEY DH SIZES
	public static final String C_DH_SIZE_1024_CMDLINE		= "1024";
	public static final String C_DH_SIZE_2048_CMDLINE		= "2048";
	public static final String C_DH_SIZE_3072_CMDLINE		= "3072";

	public static final String C_CERT_REVOKE_LIST_CMDLINE		= "--crl";
	public static final String C_LIST_ALIASES_CMDLINE		= "--list-aliases";
	public static final String C_SIGN_CMDLINE			= "--sign";
	public static final String C_MULTI_CMDLINE			= "--multi";
	public static final String C_HELP_CMDLINE			= "--help";
	public static final String C_VERSION_CMDLINE			= "--version";
	public static final String C_WIPE_CMDLINE			= "--wipe";
	public static final String C_OUTPUT_CMDLINE			= "--output";


	// ENCRYPTION ARGS
	public static final String C_CONVENTIONAL_CMDLINE		= "--conventional";
	public static final String C_CONVENTIONAL_PASSPHRASE_CMDLINE	= "--conventional-passphrase";
	public static final String C_ENCRYPT_ARMOR_CMDLINE		= "--armor";
	public static final String C_ENCRYPT_CMDLINE			= "--encrypt";
	public static final String C_DECRYPT_CMDLINE			= "--decrypt";

	// KEYS ARGS
	public static final String C_KEY_ADD_CMDLINE			= "--key-add";
	public static final String C_KEY_DETAIL_CMDLINE			= "--key-detail";
	public static final String C_KEY_EDIT_CMDLINE			= "--key-edit";
	public static final String C_KEY_EXPORT_CMDLINE			= "--key-export";
	public static final String C_KEY_EXTRACT_PHOTOID_CMDLINE	= "--extract-photoid";
	public static final String C_KEY_JOIN_CMDLINE			= "--key-join";
	public static final String C_KEY_LIST_CMDLINE			= "--key-list";
	public static final String C_KEY_GEN_CMDLINE			= "--key-gen";
	public static final String C_KEY_RECONSTRUCT_CMDLINE		= "--key-reconstruct";
	public static final String C_KEY_RECONSTRUCT_DATA_CMDLINE	= "--reconstruct-data";
	public static final String C_KEY_REMOVE_CMDLINE			= "--key-remove";
	public static final String C_KEY_SEND_SHARE_CMDLINE		= "--send-share";
	public static final String C_KEY_SIG_DETAIL_CMDLINE		= "--sig-detail";
	public static final String C_KEY_SIGN_CMDLINE			= "--key-sign";
	public static final String C_KEY_SPLIT_CMDLINE			= "--key-split";
	public static final String C_KEY_UPDATE_CMDLINE			= "--key-update";
	public static final String C_KEY_FORCE_CMDLINE			= "--force";
	public static final String C_KEY_MULTI_CMDLINE			= "--multi";
	public static final String C_KEY_WITH_PRIVATE_CMDLINE		= "--with-private";


	// KEY EDITING ARGS
	public static final String C_KEY_USERID_CMDLINE			= "--userid";
	public static final String C_KEY_PASSPHRASE_CMDLINE		= "--passphrase";
	public static final String C_KEY_KEY_TYPE_CMDLINE		= "--key-type";
	public static final String C_KEY_KEY_SIZE_CMDLINE		= "--key-size";
	public static final String C_KEY_ADD_PHOTOID_CMDLINE		= "--add-photoid";
	public static final String C_KEY_ADD_REVOKER_CMDLINE		= "--add-revoker";
	public static final String C_KEY_ADD_USERID_CMDLINE		= "--add-userid";
	public static final String C_KEY_CHANGE_PASSPHRASE_CMDLINE	= "--change-passphrase";
	public static final String C_KEY_DISABLE_CMDLINE		= "--disable";
	public static final String C_KEY_ENABLE_CMDLINE			= "--enable";
	public static final String C_KEY_REMOVE_PHOTOID_CMDLINE		= "--remove-photoid";
	public static final String C_KEY_REMOVE_SIG_CMDLINE		= "--remove-sig";
	public static final String C_KEY_REMOVE_SUBKEY_CMDLINE		= "--remove-subkey";
	public static final String C_KEY_REMOVE_USERID_CMDLINE		= "--remove-userid";
	public static final String C_KEY_REVOKE_CMDLINE			= "--revoke";
	public static final String C_KEY_REVOKE_SIG_CMDLINE		= "--revoke-sig";
	public static final String C_KEY_REVOKE_SUBKEY_CMDLINE		= "--revoke-subkey";
	public static final String C_KEY_SET_PRIMARY_USERID_CMDLINE	= "--set-primary-userid";
	public static final String C_KEY_TRUST_CMDLINE			= "--trust";

	// KEY SERVER ARGS
	public static final String C_KEY_SERVER_URL_CMDLINE		= "--keyserver";
	public static final String C_KEY_SERVER_DELETE_CMDLINE		= "--keyserver-delete";
	public static final String C_KEY_SERVER_DISABLE_CMDLINE		= "--keyserver-disable";
	public static final String C_KEY_SERVER_FETCH_CMDLINE		= "--keyserver-fetch";
	public static final String C_KEY_SERVER_SEARCH_CMDLINE		= "--keyserver-search";
	public static final String C_KEY_SERVER_SEND_CMDLINE		= "--keyserver-send";

	// GROUP ARGS
	public static final String C_GROUP_CMDLINE			= "--group";
	public static final String C_GROUP_ADD_CMDLINE			= "--group-add";
	public static final String C_GROUP_DETAIL_CMDLINE		= "--group-detail";
	public static final String C_GROUP_LIST_CMDLINE			= "--group-list";
	public static final String C_GROUP_REMOVE_CMDLINE		= "--group-remove";
	public static final String C_GROUPSFILE_CMDLINE			= "--groupsfile";

	// SMARTCARD ARGS
	public static final String C_SMARTCARD_CMDLINE			= "--smartcard";
	public static final String C_SMARTCARD_DLL_CMDLINE		= "--smartcard-dll";
	public static final String C_SMARTCARD_TYPE_CMDLINE		= "--smartcard-type";
	public static final String C_SMARTCARD_PIN_CMDLINE		= "--pin";
	public static final String C_SMARTCARD_PIND_FD_CMDLINE		= "--pin-fd";

	// ISSUER ARGS
	public static final String C_ISSUER_DN_CMDLINE			= "--issuer-dn";
	public static final String C_ISSUER_SERIAL_CMDLINE		= "--issuer-serial";

	// x509 ARGS
	public static final String C_XOP_CERT_CMDLINE			= "--x509";
	public static final String C_XOP_CERT_REQUEST_CMDLINE		= "--cert-request";
	public static final String C_XOP_CERT_RETRIEVE_CMDLINE		= "--cert-retrieve";
	public static final String C_XOP_CERT_NEW_NON_UNIQUE_CMDLINE	= C_KEY_SIGN_CMDLINE + " " + C_ISSUER_DN_CMDLINE;
	public static final String C_XOP_CERT_NEW_UNIQUE_CMDLINE	= C_KEY_SIGN_CMDLINE + " " + C_ISSUER_SERIAL_CMDLINE;
	public static final String C_XOP_CERT_NEW_SIG_CMDLINE		= C_KEY_SIGN_CMDLINE + " " + C_XOP_CERT_CMDLINE;
	public static final String C_XOP_CERT_EXPORT_NON_UNIQUE_CMDLINE	= C_KEY_EXPORT_CMDLINE + " " + C_ISSUER_DN_CMDLINE;
	public static final String C_XOP_CERT_EXPORT_UNIQUE_CMDLINE	= C_KEY_EXPORT_CMDLINE + " " + C_ISSUER_SERIAL_CMDLINE;
	public static final String C_XOP_CERT_EXPORT_ONLY_X_CMDLINE	= C_KEY_EXPORT_CMDLINE + " " + C_XOP_CERT_CMDLINE;
	public static final String C_XOP_FETCH_CERT_REVOKE_LIST_CMDLINE = C_KEY_UPDATE_CMDLINE + " " + C_CERT_REVOKE_LIST_CMDLINE;
	public static final String C_XOP_UPDATE_CMDLINE			= C_KEY_UPDATE_CMDLINE + " " + C_XOP_CERT_CMDLINE;
}