/*____________________________________________________________________________
Copyright (C) 2000 Networks Associates Technology, Inc.
All rights reserved.

$Id: PGPeBizJava_RunMode.java,v 1.1 2003/10/27 23:46:21 ishabtay Exp $
____________________________________________________________________________*/

/************************************************************
 *
 * Filename:		PGPeBizJava_RunMode.java
 *
 * Author:		Alex Faieta
 * Date:		September 12, 2001
 * Editor:		Notepad
 * Java Version:	Sun Java 1.3.1
 * Description:		Resource file for run-time options
 *			within this application.
 *
 ************************************************************/


public final class PGPeBizJava_RunMode
{
	// default directory paths
	public static final String[] m_dirPaths	= {	"./encrypt/", 
							"./encrypted/",
							"./decrypted/",
							"./keyexport/"	};
 

	public static final String[] m_publicKeyAlgs = {	"DH/DSS (default)",
								"RSA (not compatible with RSA Legacy keys)",
								"RSA Legacy"	};

	public static final String[] m_DHKeySizes = {	"1024 bits",
							"2048 bits",
							"3072 bits"	};

	public static final int INVALID_OPTION	= 0;
	public static final int CANCEL_OPTION	= INVALID_OPTION + 1;
	public static final int ENCRYPT_FILE	= INVALID_OPTION + 2;
	public static final int DECRYPT_FILE	= INVALID_OPTION + 3;
	public static final int COMPARE_FILES	= INVALID_OPTION + 4;
	public static final int LIST_ALL_KEYS	= INVALID_OPTION + 5;
	public static final int LIST_KEY_INFO	= INVALID_OPTION + 6;
	public static final int LOAD_KEY_ID	= INVALID_OPTION + 7;
	public static final int HELP_COMMAND	= INVALID_OPTION + 8;
	public static final int RUN_COMMAND	= INVALID_OPTION + 9;
	public static final int KEY_ADD_NEW	= INVALID_OPTION + 10;
	public static final int CLEAR_DATA	= INVALID_OPTION + 11;
	public static final int DELETE_KEY_ID	= INVALID_OPTION + 12;
	public static final int WIPE_FILES	= INVALID_OPTION + 13;
	public static final int EXPORT_KEY	= INVALID_OPTION + 14;
	public static final int IMPORT_KEY	= INVALID_OPTION + 15;
}
